package hexIT;

import javax.swing.*;
import java.awt.*;

public abstract class HexPanel extends JPanel
{
   protected Board board;
   
   protected double  sin30= 0.5000000, 
                     cos30= 0.8660254;
                     
   protected int totalWidth, totalHeight, viewportWidth, viewportHeight, topLeftX, topLeftY, sideLength;   
   protected int boardSize;    // size of the board .. not pixels, in hexagons

   protected Color bgColor;  
   protected boolean scale= false;
	
   public HexPanel(int new_width, int new_height, int new_boardSize, Color new_bgColor)
   {
      totalWidth= new_width;
      totalHeight= new_height;
      boardSize= new_boardSize;
      bgColor= new_bgColor;
      
      // chop off 5% of the width & height      
      setViewportWidth((int)((double)totalWidth - (0.1 * ((double)totalWidth))));
      setViewportHeight((int)((double)totalHeight - (0.1 * ((double)totalHeight))));
   }

   public void setViewportHeight(int newHeight)
   {
      viewportHeight= newHeight;
      topLeftY= (totalHeight-viewportHeight)/2;
   }
    
   public void setViewportWidth(int newWidth)
   {
      viewportWidth= newWidth;
      topLeftX= (totalWidth-viewportWidth)/2;
   }

   public Color getBackgroundColor()
   {
      return bgColor;
   }

   public void setScale(boolean new_scale)
   {
      boolean oldscale= scale;
      scale= new_scale;
      
      if (oldscale == false && new_scale == true)
         scaleAllImages();
   }
   
   public void setBackgroundColor(Color new_bgColor)
   {
      bgColor= new_bgColor;
      repaint();
   }    
   
   public Board getBoard()
   {
      return board;
   }
   	
   public abstract void putObject(int x, int y, Drawable object);
   public abstract void removeObject(int x, int y);   
   //public abstract void drawHexagon(int x, int y, Color drawingColor);
   public abstract void showGrid(Color drawingColor);
   public abstract void hideGrid(); 
   public abstract void scaleAllImages();
   
   public abstract void setHexOutlineColor(int hexx, int hexy, Color color);
   public abstract void setHexFillColor(int hexx, int hexy, Color color);
}

