package server;

import java.io.*;
import java.net.*;

public class ClientHandler extends Thread
{
	private int mycolor;
	private Socket clientSock;
	private Main main;
	private BufferedReader sockIn;
	private PrintStream sockOut;

	public ClientHandler(Socket _clientSock, Main _main, int _color)
	{
		clientSock= _clientSock;
		main= _main;
		mycolor= _color;

		try
		{
			sockIn= new BufferedReader(new InputStreamReader(clientSock.getInputStream()));
			sockOut= new PrintStream(clientSock.getOutputStream());
		}
		catch(Exception e)
		{
			e.printStackTrace();
			System.exit(-1);
		}
	}

	private void checkEnd()
	{
		if (main.gameEnded())
		{
			try
			{
				System.out.println("Press enter...");
				BufferedReader br= new BufferedReader(new InputStreamReader(
					System.in));
				br.readLine();
			}
			catch (Exception e)
			{
				//e.printStackTrace();
			}

			System.exit(-1);
		}
	}

	public void run()
	{
		String inputLine;
		int winner;

		try
		{
			while (true)
			{
				inputLine= sockIn.readLine();

				main.processMessage(inputLine, mycolor);

				checkEnd();
			}
		}
		catch(Exception e)
		{
			//e.printStackTrace();
			checkEnd();
			System.exit(-1);
		}
	}

	public synchronized void send(String msg)
	{
		System.out.println("Sending: " + msg);
		sockOut.println(msg);
	}

}

