package server;

import java.io.*;
import java.util.*;

public class HighScore implements Serializable
{
	private HashMap map;
	private String highscoreName;

	private HighScore(String _highscoreName)
	{
		highscoreName= _highscoreName;
		map= new HashMap();
	}

	public void update(String key, int points)
	{
		Integer i= (Integer)map.get(key);

		if (i == null)
		{
			map.put(key, new Integer(points));
		}
		else
		{
			map.put(key, new Integer(i.intValue() + points));
		}
	}

	/* Must call to create the first highscore */
	public static HighScore loadHighScore(String highscoreName)
   {
      FileInputStream inputStream= null;
      FileOutputStream outputStream= null;
      ObjectInputStream inStream= null;
      ObjectOutputStream outStream= null;
		HighScore highscore= null;

      try
      {
         // now re-open the filestream because we've created the dbfile
         inputStream= new FileInputStream(highscoreName + ".dat");

         inStream= new ObjectInputStream(inputStream);
         highscore= (HighScore)inStream.readObject();

         inStream.close();
         inputStream.close();
      }
      catch(Exception e)
      {
         try
         {
            // make a new file
            outputStream= new FileOutputStream(highscoreName + ".dat");
            outStream= new ObjectOutputStream(outputStream);

            highscore= new HighScore(highscoreName);

            // write the empty serialized hash map to the new file
            outStream.writeObject(highscore);

            outStream.close();
            outputStream.close();
         }
         catch(Exception ex2)
         {
            System.out.println("SHOULD NOT GET HERE");
            ex2.printStackTrace();
         }
      }

		return highscore;
   }

   public static void updateHighScoreFile(HighScore highscore)
   {
      try
      {
         FileOutputStream o= new FileOutputStream(highscore.highscoreName + ".txt");
         PrintStream outStream= new PrintStream(o);

         FileOutputStream o2= new FileOutputStream(highscore.highscoreName + ".dat");
         ObjectOutputStream outStream2= new ObjectOutputStream(o2);
         outStream2.writeObject(highscore);

         outStream.println(highscore.toString());

         o.close();
         outStream.close();
      }
      catch(Exception e)
      {
         //System.out.println("ERROR in updateHighScoreFiles");
			e.printStackTrace();
      }
   }

	public String toString()
	{
		String s= "";

		HashMap newmap= (HashMap)map.clone();
		String maxKey= "";

		while (newmap.keySet().size() > 0)
		{
			int max= -100;
			Iterator keysIter= newmap.keySet().iterator();

			while (keysIter.hasNext())
			{
				String key= (String)keysIter.next();
				Integer i= (Integer)newmap.get(key);

				if (i.intValue() >= max)
				{
					maxKey= key;
					max= i.intValue();
				}
			}

			String num= max + "";
			for (int i= 0; i < (5-num.length()); i++)
				num = " " + num;

			s += (num + "   " + maxKey + "\n");
			newmap.remove(maxKey);
		}

		return s;
	}
}
